package jp.kirikiri.tjs2;

public class Interface {

	/** メンバーが存在しない時、メンバーを生成する
	 * create a member if not exists */
	static final public int MEMBERENSURE		= 0x00000200;

	/** メンバーは存在しなければならない member *must* exist ( for Dictionary/Array ) */
	static final public int MEMBERMUSTEXIST 	= 0x00000400;

	/** プロパティの呼び出しを行わない ignore property invoking */
	static final public int IGNOREPROP			= 0x00000800;

	/** 非表示メンバー member is hidden */
	static final public int HIDDENMEMBER		= 0x00001000;

	/** スタティックメンバー、オブジェクト生成時にコピーされない
	 * member is not registered to the object (internal use) */
	static final public int STATICMEMBER		= 0x00010000;

	/** EnumMembers コール時にメンバの実体取得を行わない
	 * values are not retrieved (for EnumMembers) */
	static final public int ENUM_NO_VALUE		= 0x00100000;

	static final public int
		NIS_REGISTER		= 0x00000001,	// set native pointer
		NIS_GETINSTANCE		= 0x00000002,	// get native pointer
		CII_ADD				= 0x00000001,	// register name
											// 'num' argument passed to CII is to be igonored.
		CII_GET				= 0x00000000,	// retrieve name
		CII_SET_FINALIZE	= 0x00000002,	// register "finalize" method name
											// (set empty string not to call the method)
											// 'num' argument passed to CII is to be igonored.
		CII_SET_MISSING		= 0x00000003;	// register "missing" method name.
											// the method is called when the member is not present.
											// (set empty string not to call the method)
											// 'num' argument passed to CII is to be igonored.
											// the method is to be called with three arguments;
											// get_or_set    : false for get, true for set
											// name          : member name
											// value         : value property; you must
											//               : dereference using unary '*' operator.
											// the method must return true for found, false for not-found.


	static final public int
		nitMethod	= 1,
		nitProperty = 2;
}
